module Model exposing (..)

import Config.DataTableConfig as DataTableConfig
import Config.ForceDirectedGraph as ForceDirectedGraphConfig
import Config.MapViewConfig as MapConfig
import Config.BarPlotConfig as BarPlotConfig
import Config.LinePlotConfig as LinePlotConfig
import Data.DataLoader exposing (Entry)


type View
    = Home
    | Other
    | MapView
    | DataTable
    | ForceDirectedGraph
    | BarPlot
    | LinePlot


type Progress
    = Loading
    | Success
    | Failure String


type alias Global =
    { view : View
    , progress : Progress
    , data : List Entry

    -- extend as needed...
    , selectedCountry : Maybe String
    , selectedConsulateCountry : Maybe String
    }


type alias Local =
    { map : MapConfig.Model
    , dataTable : DataTableConfig.Model
    , forcedirectedgraph : ForceDirectedGraphConfig.Model
    , barplot : BarPlotConfig.Model
    , lineplot : LinePlotConfig.Model

    -- extend as needed...
    }


type alias Model =
    ( Global, Local )

